/*                                                                          
  Ŀ
   EJEMPLO3.C                                                             
                                                                          
   Ejemplo de dibujo de pixels. Campo de estrellas 2D.                    
                                                                          
   Compilado con :  Borland C/C++ v3.1                                    
   Cdigo y texto:  [NoP] de Compiler SoftWare.                     
  1997 C.S.
*/

#include <stdio.h>               /* funciones estndar Input/Output */
#include <dos.h>                 /* funcin pokeb(); */
#include <time.h>                /* funcin randomize(); */
#include <stdlib.h>              /* nmero aleatorios */
#include <conio.h>               /* funcin getch(); */
#include "ints.h"                /* librera con funciones varias int 10h */
#include "mode13h.h"             /* librera con funciones 320x200x256 */

#define NUM_STARS 120

struct Estrella 
{
  int x, y;
  char color;
  char velocidad;
};

struct Estrella Stars[NUM_STARS];

void CreateStars( void );
void MoveStars( void );

/*  Funcin principal main()  */

void main( void )
{

 SetVideoMode( 3 );                       /* inicializar 80x25x16 (3h) */

 printf("EJEMPLO3.EXE\r\n");
 printf("\r\nEste ejemplo utiliza la funcin PutPixel() para dibujar un campo de estrellas\r\n");
 printf("2D. Usa 3 tipos de estrellas con diferentes colores y velocidades.\r\n\n");
 
 printf("Pulse cualquier tecla para ejecutar el programa...");
 getch();

 SetVideoMode( 0x13 );                    /* inicializar 320x200x256 (13h) */
 CreateStars();                                   /* creamos las estrellas */

 while( !kbhit() ) 
           MoveStars();

 SetVideoMode( 3 );                       /* inicializar 80x25x16 (3h) */
}

/*-------------------------------------------------------------------------
  Para cada 1 de las estrellas ( desde 0 a NUM_STARS) :
    Cogemos una x e y aleatorias dentro de la pantalla.
    Cogemos una velocidad aleatoria entre 1 y 3.
    Segn la velocidad que lleve (1-3) la estrella estar ms cercana y
     tendr un color ms claro. Usamos 3 grises de distintas tonalidades
     segn la velocidad de la estrella ( vel 1 = color 23; 2 = 7; 3 = 15 ).
 -------------------------------------------------------------------------*/
void CreateStars( void )
{
 int bucle;
 randomize();
  
  for( bucle=0; bucle<NUM_STARS; bucle++ )
   {
     Stars[bucle].x = random(320);
     Stars[bucle].y = random(200);
     Stars[bucle].velocidad = random(3)+1;

     if( Stars[bucle].velocidad == 1 ) Stars[bucle].color = 23;
     else if( Stars[bucle].velocidad == 2 ) Stars[bucle].color = 7;
     else Stars[bucle].color = 15;
   }
}

/*-------------------------------------------------------------------------
  Para cada 1 de las estrellas ( desde 0 a NUM_STARS) :
    x = x-velocidad
    Borramos la estrella antigua ((x,y) = 0 = negro)
    si ( x<0 ) x = 320 
      (es decir: si se sale de la pantalla, la ponemos de nuevo al final).
    Dibujamos la nueva estrella ((x,y) = color)
 -------------------------------------------------------------------------*/
void MoveStars( void )
{
 int bucle;
 randomize();
  
  WaitVRetrace();                                     /* ralentizar efecto */

  for( bucle=0; bucle<NUM_STARS; bucle++ )
   {
     PutPixel( Stars[bucle].x, Stars[bucle].y, 0 );

     Stars[bucle].x -= Stars[bucle].velocidad;
     if( Stars[bucle].x < 0 ) Stars[bucle].x = 320;
     
     PutPixel( Stars[bucle].x, Stars[bucle].y, Stars[bucle].color );
   }
}
