/*                                                                          
  Ŀ
   EJEMPLO4.C                                                             
                                                                          
   Ejemplo de dibujo de sprites y aplicaciones de las distintas funciones.
                                                                          
   Compilado con :  Borland C/C++ v3.1                                    
   Cdigo y texto:  [NoP] de Compiler SoftWare.                     
  1997 C.S.
*/

#include <stdio.h>               /* funciones estndar Input/Output */
#include <dos.h>                 /* funcin pokeb(); */
#include <conio.h>               /* funcin getch(); */
#include "ints.h"                /* librera con funciones varias int 10h */
#include "mode13h.h"             /* librera con funciones 320x200x256 */

#include "sprites.h"             /* los sprites y el mapa del juego */

int xplayer, yplayer;
void DoGame( void );
void DrawWall( int, int );
void DrawGround( int, int );
void DrawPlayer( int, int );

/*  Funcin principal main()  */

void main( void )
{

 SetVideoMode( 3 );                       /* inicializar 80x25x16 (3h) */

 printf("EJEMPLO4.EXE\r\n");
 printf("\r\nEste ejemplo es una pequea muestra del uso de las distintas funciones que\r\n");
 printf("hemos desarrollado, pero sirve para demostrar que conforme vayamos avanzando en\r\n");
 printf("el curso y vayamos optimizando y desarrollando nuevas funciones podremos reali-\r\n");
 printf("zar cualquier tipo de programa. Este ejemplo usa nicamente <PutPixel()>...\r\n");
 printf("Use los cursores para mover el Sprite y ESCAPE para salir al DOS.\r\n\n");

 printf("Pulse cualquier tecla para realizar la prueba...");
 getch();

 SetVideoMode( 0x13 );                    /* inicializar 320x200x256 (13h) */
 ClearScreen( 0 );                        /* limpiar videoram con color 1 */

 DoGame();

 SetVideoMode( 3 );                       /* inicializar 80x25x16 (3h) */

 printf("Pese a ser un ejemplo muy simple, a base de optimizar ms las funciones\r\n");
 printf("grficas e incluir ms opciones, enemigos, etc..., puede ir amplindose\r\n");
 printf("este ejemplo y que cada lector cree sus propios programas o juegos.\r\n");
}

/*------------------------------------------------------------------------*/

void DoGame( void )
{
char tecla = 1;
int buclex, bucley;

/* imprimimos el mapa completo a base de dibujar todos los bloques leyendo
   desde el array y dibujando huecos o muros segn el valor en cada x,y */

 for( bucley=0; bucley<12; bucley++ )
  for( buclex=0; buclex<20; buclex++ )
   {
     if( Pantalla[(bucley*20)+buclex] == 0 )
       DrawGround( buclex*16, bucley*16 );
   
     else if( Pantalla[(bucley*20)+buclex] == 1 )
       DrawWall( buclex*16, bucley*16 );
   }

/* inicializamos las variables del programa: */

 xplayer = 1; yplayer = 1;
 DrawPlayer( xplayer*16, yplayer*16 );

/* mientras no se pulse ESCAPE, repetir: */
 while( tecla != 27 )
 {
   tecla = getch();
   if( tecla == 0 )              /* si es una tecla especial (cursores)... */
   {
    tecla = getch();                          /* cogemos segundo scan code */
     
     if( tecla == 72 )                           /* si pulsa CURSOR ARRIBA */
        {
          if( yplayer > 0 )                     /* si no estamos arriba... */
           if( Pantalla[((yplayer-1)*20)+xplayer] == 0 )
           {
            DrawGround( xplayer*16, yplayer*16 );
            yplayer--;
            DrawPlayer( xplayer*16, yplayer*16 );
           }
        }
     
     else if( tecla == 80 )                       /* si pulsa CURSOR ABAJO */
        {
          if( yplayer < 11 )                    /* si no estamos arriba... */
           if( Pantalla[((yplayer+1)*20)+xplayer] == 0 )
           { 
            DrawGround( xplayer*16, yplayer*16 );
            yplayer++;
            DrawPlayer( xplayer*16, yplayer*16 );
           }
        }
 
     else if( tecla == 75 )                      /* si pulsa CURSOR IZQUI. */
        {
          if( xplayer > 0 )                     /* si no estamos arriba... */
           if( Pantalla[(yplayer*20)+(xplayer-1)] == 0 )
           {
            DrawGround( xplayer*16, yplayer*16 );
            xplayer--;
            DrawPlayer( xplayer*16, yplayer*16 );
           }
        }
     
     else if( tecla == 77 )                      /* si pulsa CURSOR DEREC. */
        {
          if( xplayer < 19)                     /* si no estamos arriba... */
           if( Pantalla[(yplayer*20)+(xplayer+1)] == 0 )
           {
            DrawGround( xplayer*16, yplayer*16 );
            xplayer++;
            DrawPlayer( xplayer*16, yplayer*16 );
           }
        }
 
     }
  }
}

/*------------------------------------------------------------------------*/
void DrawPlayer( int x, int y )
{
 int vx, vy;

  for( vy=0; vy<16; vy++ )
   for( vx=0; vx<16; vx++ )
    PutPixel( x+vx, y+vy, FiguraPlayer[(vy*16)+vx] );

}

/*------------------------------------------------------------------------*/
void DrawWall( int x, int y )
{
 int vx, vy;

  for( vy=0; vy<16; vy++ )
   for( vx=0; vx<16; vx++ )
    PutPixel( x+vx, y+vy, FiguraWall[(vy*16)+vx] );

}

/*------------------------------------------------------------------------*/
void DrawGround( int x, int y )
{
 int vx, vy;

  for( vy=0; vy<16; vy++ )
   for( vx=0; vx<16; vx++ )
    PutPixel( x+vx, y+vy, FiguraGround[(vy*16)+vx] );

}

