/*                                                                          
  Ŀ
   Grafico.c                                                              
                                                                          
   Ejemplo de como gracias a la funcin PutPixel podemos ahora generar    
   cualquier tipo de grfico. Dibuja un bitmap (bloque de pixels) en pan- 
   talla usando PutPixel en 320x200x256.                                  
   Por supuesto, dos bucles es la manera ms <sucia> de dibujar un sprite 
   o bitmap pero por ahora vale como ejemplo (se trararn proximamente).  
   Tambin cambia la paleta de la VGA para cambiar el juego de 256 colores
   (hay veces que es necesario cambiar los colores por defecto para con-  
    seguir ms carnes, rosas, etc... ).                                   
                                                                          
   Compilado con :  Borland C/C++ v3.1                                    
   Cdigo y texto:  [NoP] de Compiler SoftWare.                     
  1997 C.S.
*/

#include <stdio.h>               /* funciones estndar Input/Output */
#include <dos.h>                 /* para pokeb(); */
#include <conio.h>               /* funcin getch(); */
#include "ints.h"                /* librera con funciones varias int 10h */
#include "mode13h.h"             /* librera con funciones 320x200x256 */

#include "grafico.h"             /* el grfico convertido a un array */

int x, y;

void Info( void );                         /* informacin en pantalla */
void SetPalette( char far * );             /* cambio de paleta */


/*  Funcin principal main()  */

void main( void )
{

 Info();
 SetVideoMode( 0x13 );                    /* inicializar 320x200x256 (13h) */

/*--- dibujamos el sprite -------------------------------------------------*/
 
 for( y=0; y<alto; y++ )
   for( x=0; x<ancho; x++ )
     PutPixel( x, y, array[(y*ancho)+x] );

/*-------------------------------------------------------------------------*/
 
 getch();                                 /* esperar a que pulse una tecla */

 SetPalette( AmberPal );                  /* poner la paleta original */

 getch();                                 /* esperar a que pulse una tecla */

 SetVideoMode( 3 );                       /* inicializar 80x25x16 (3h) */
 

}


/*--------------------------------------------------------------------------
  Hemos puesto la informacin en una funcin aparte para que al mirar la
  funcin principal main() se vea ms facilmente cmo se dibuja el sprite.
 --------------------------------------------------------------------------*/

void Info( void )
{
 SetVideoMode( 3 );                       /* inicializar 80x25x16 (3h) */

 printf("GRAFICO.EXE\r\n");
 printf("\r\nEn este ejemplo inicializamos el modo grfico 320x200x256 (13h) y dibu-\r\n");
 printf("jamos un bloque de pixels en pantalla (la imagen de una mujer (Amber),\r\n");
 printf("La imagen est guardada en un array con todos los pixels que la componen,\r\n");
 printf("linea por lnea (ejemplo):\r\n\n");
 printf(" XXOOO\r\n");
 printf(" XXOO\r\n");
 printf(" XXXOO     =   array[10*5] = { 0,1,0,1,0,0,2,2,2 ..., 0 }; \r\n");
 printf(" XXOO\r\n");
 printf(" XXOOO\r\n\n");

 printf("Luego dibujamos este array en pantalla usando PutPixel():\r\n\n");
 printf(" for( y=0; y<alto; y++ )\r\n");
 printf("   for( x=0; x<ancho; x++ )\r\n");
 printf("     PutPixel( x, y, array[x][y] );\r\n\n");
 
 
 printf("Esta es una manera muy lenta de dibujar bitmaps, pero eso ya lo trataremos ms\r\n");
 printf("adelante. Lo que cuenta es que la imagen se cre con una paleta diferente (para\r\n");
 printf("dibujar una cara es preciso tener ms colores carne, rosas...) as que primero\r\n");
 printf("lo veremos con la paleta normal y luego cambiaremos la paleta poniendo los co-\r\n");
 printf("lores originales de la imagen (tema que trataremos el prximo artculo).");
 getch();

}

/*--------------------------------------------------------------------------
  Cambio de la paleta por defecto de la VGA.
  El prximo artculo comentaremos esta y otras funciones y efectos.
 --------------------------------------------------------------------------*/

void SetPalette( char far *pal_array )
{
asm {
        les dx, pal_array
        xor bx, bx
        mov cx, 256
        mov ax, 1012h
        int 10h
    }
}
