/*                                                                          
  Ŀ
   TEST1.C                                                                
   Este programa realiza un testeo de velocidad entre PutPixelMul(),      
   PutpixelC() y PutPixel() para comprobar la diferencia de velocidad     
   entre pixels con multiplicaciones, con pokeb() de c, y con desplaza-   
   mientos, respectivamente. Testea 3 segundos cada funcin.              
                                                                          
   Compilado con :  Borland C/C++ v3.1                                    
   Cdigo y texto:  [NoP] de Compiler SoftWare.                     
  1997 C.S.
*/

#include <stdio.h>                       /* standard input/output (printf) */
#include <dos.h>                         /* pokeb() */
#include <conio.h>                       /* getch y cprintf... */
#include <time.h>                        /* control de tiempo */
#include "ints.h"                        /* funcin Int_PutPixel(); */
#include "mode13h.h"                     /* PutPixelC(); y PutPixel(); */

#define tiempo 3
   
clock_t start, end;
long puntos_c=0, puntos_mul=0, puntos_shl=0;
long numpuntos_c, numpuntos_mul, numpuntos_shl;
char color;

/* Funcin principal main() -*/

int main(void)
{
 
 SetVideoMode( 3 );              /* inicializar 80x25x16 colores (modo 3) */
 
 printf("TEST1.EXE\r\n\n");
 printf("Este programa testea la velocidad de las rutinas:\r\n\n");
 printf("PutPixelMul();     -> Dibujo de pixels mediante pokeb() (C puro)\r\n");
 printf("PutPixelC();       -> Dibujo de pixels mediante acceso a la VRAM (y*320+x)\r\n");
 printf("PutPixel();        -> Dibujo de pixels mediante acceso a la VRAM (<<)\r\n\n");
 printf("Testear cada rutina 3 segundos (total 9 segundos) dibujando el mayor nmero\r\n");
 printf("de pixels posibles en la posicin (160,100). Luego mostrar los resultados.\r\n\n");

 printf("Pulse cualquier tecla para realizar el test...");
 getch();                        /* esperar la pulsacin de una tecla */ 

 SetVideoMode( 0x13 );           /* inicializar 320x200x256 colores (13h) */


/* TEST DE Int_PutPixel() */
   start = clock();
   while( (end= (clock()-start)/CLK_TCK) < tiempo )
    {
      Int_PutPixel( 160, 100, color );
      color++;
      puntos_c++;
    }
   
   numpuntos_c = puntos_c/tiempo;

   ClearScreen(0);                   /* borrar la pantalla con el color 0 */


/* TEST DE PutPixelC() */
   start = clock();
   while( (end= (clock()-start)/CLK_TCK) < tiempo )
    {
      PutPixelC( 160, 100, color );
      color++;
      puntos_mul++;
    }
   
   numpuntos_mul = puntos_mul/tiempo;

   ClearScreen(0);                   /* borrar la pantalla con el color 0 */


/* TEST DE PutPixel() */
   start = clock();
   while( (end= (clock()-start)/CLK_TCK) < tiempo )
    {
      PutPixel( 160, 100, color );
      color++;
      puntos_shl++;
    }
   
   numpuntos_shl = puntos_shl/tiempo;

   /* volver al modo de texto e informar de los resultados */
   SetVideoMode( 3 );                                   /* modo 3 : 80x25 */

   printf("Test de velocidad. Comparacin pokeb/C/ASM\r\n");
   printf("-------------------------------------------------------------------\r\n\n");
   printf("Resultados (nmero de pixels por segundo)...\r\n\n");
   printf("Usando mult. C y pokeb()   :     %10.0f por segundo.\r\n", (float) numpuntos_c );
   printf("Usando multiplicacin C    :     %10.0f por segundo.\r\n", (float) numpuntos_mul );
   printf("Usando desplazamientos shl :     %10.0f por segundo.\r\n", (float) numpuntos_shl );

   return(0);
}                                              
